//
//	STELSOCK	(SSL Telnet Socket)
//
//	Copyright (C) 1996,1997 NEC Corporation
//	All rights reserved.
//  Authos(s): Mizukoshi, Yasuhiro <mizukosi@ccs.mt.nec.co.jp>
//

//	    $Archive: /sotools/stelsock/auth.h $
//			$Revision: 6 $
//			$Date: 97/09/08 10:45a $

#include	<windows.h>
#include	<winsock.h>

#include	"ssl.h"

// NVT Control Code
#define	IAC			255

// Option Control Codes
#define	WILL		251
#define	WONT		252
#define	DO			253
#define	DONT		254
#define	SE			240
#define	SB			250


// Authentication Commands
#define	AUTHENTICATION		37
#define		IS					0
#define		SEND				1
#define		REPLY				2
#define		NAME				3

// Authentication Types
#define	TYPE_KERBEROS_V4		1
#define	TYPE_KERBEROS_V5		2
#define	TYPE_SPX				3
#define	TYPE_RSA				6
#define	TYPE_SSL				7
#define	TYPE_LOKI				10

// Modifiers
#define	AUTH_WHO_MASK			1
#define	AUTH_CLIENT_TO_SERVER	0
#define	AUTH_SERVER_TO_CLIENT	1
#define	AUTH_HOW_MASK			2
#define	AUTH_HOW_ONE_WAY		0
#define	AUTH_HOW_MUTIAL			2

// SSL Type
#define	AUTH_SSL_START			1
#define	AUTH_SSL_ACCEPT			2
#define	AUTH_SSL_REJECT			3


// SSL telnet negotiation
int DoSSLTelnet(SOCKET s);
int RecvTelnetCmd(SOCKET s, char *buf, int len, int flag);


#define	AUTH_SSL				"AUTH SSL\r\n"
#define	TMPBUF_SIZ				1024

// SSL ftp negotiation
int DoSSLFtp(SOCKET s);
